import {HTTPClient as $42h8L$HTTPClient} from "koajax";
import {buildURLData as $42h8L$buildURLData} from "web-utility";
import {observable as $42h8L$observable} from "mobx";
import {Stream as $42h8L$Stream, ListModel as $42h8L$ListModel, toggle as $42h8L$toggle} from "mobx-restful";


function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}
var $16892940cfb7bd51$exports = {};

$parcel$export($16892940cfb7bd51$exports, "congressClient", function () { return $16892940cfb7bd51$export$8a5579aecc40808e; });
$parcel$export($16892940cfb7bd51$exports, "createListStream", function () { return $16892940cfb7bd51$export$21e1cdb092ff7d8c; });


var $16892940cfb7bd51$var$__await = undefined && undefined.__await || function(v) {
    return this instanceof $16892940cfb7bd51$var$__await ? (this.v = v, this) : new $16892940cfb7bd51$var$__await(v);
};
var $16892940cfb7bd51$var$__asyncValues = undefined && undefined.__asyncValues || function(o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
        return this;
    }, i);
    function verb(n) {
        i[n] = o[n] && function(v) {
            return new Promise(function(resolve, reject) {
                v = o[n](v), settle(resolve, reject, v.done, v.value);
            });
        };
    }
    function settle(resolve, reject, d, v) {
        Promise.resolve(v).then(function(v) {
            resolve({
                value: v,
                done: d
            });
        }, reject);
    }
};
var $16892940cfb7bd51$var$__asyncDelegator = undefined && undefined.__asyncDelegator || function(o) {
    var i, p;
    return i = {}, verb("next"), verb("throw", function(e) {
        throw e;
    }), verb("return"), i[Symbol.iterator] = function() {
        return this;
    }, i;
    function verb(n, f) {
        i[n] = o[n] ? function(v) {
            return (p = !p) ? {
                value: $16892940cfb7bd51$var$__await(o[n](v)),
                done: false
            } : f ? f(v) : v;
        } : f;
    }
};
var $16892940cfb7bd51$var$__asyncGenerator = undefined && undefined.__asyncGenerator || function(thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = Object.create((typeof AsyncIterator === "function" ? AsyncIterator : Object).prototype), verb("next"), verb("throw"), verb("return", awaitReturn), i[Symbol.asyncIterator] = function() {
        return this;
    }, i;
    function awaitReturn(f) {
        return function(v) {
            return Promise.resolve(v).then(f, reject);
        };
    }
    function verb(n, f) {
        if (g[n]) {
            i[n] = function(v) {
                return new Promise(function(a, b) {
                    q.push([
                        n,
                        v,
                        a,
                        b
                    ]) > 1 || resume(n, v);
                });
            };
            if (f) i[n] = f(i[n]);
        }
    }
    function resume(n, v) {
        try {
            step(g[n](v));
        } catch (e) {
            settle(q[0][3], e);
        }
    }
    function step(r) {
        r.value instanceof $16892940cfb7bd51$var$__await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r);
    }
    function fulfill(value) {
        resume("next", value);
    }
    function reject(value) {
        resume("throw", value);
    }
    function settle(f, v) {
        if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]);
    }
};
const $16892940cfb7bd51$export$8a5579aecc40808e = new (0, $42h8L$HTTPClient)({
    baseURI: 'https://api.congress.gov/v3/',
    responseType: 'json'
});
const $16892940cfb7bd51$export$21e1cdb092ff7d8c = ()=>(key)=>function openStream() {
            return $16892940cfb7bd51$var$__asyncGenerator(this, arguments, function* openStream_1() {
                var totalCount = 0;
                for(let pageIndex = 1, pageSize = 10;; pageIndex++){
                    const { body: body } = yield $16892940cfb7bd51$var$__await(this.client.get(`${this.baseURI}?${(0, $42h8L$buildURLData)({
                        offset: (pageIndex - 1) * pageSize,
                        limit: pageSize
                    })}`));
                    const list = body[key];
                    if (!list[0]) break;
                    totalCount += list.length;
                    yield $16892940cfb7bd51$var$__await((yield* $16892940cfb7bd51$var$__asyncDelegator($16892940cfb7bd51$var$__asyncValues(list))));
                    if (list.length < pageSize) break;
                }
                this.totalCount = totalCount;
            });
        };


var $123f7ae3df81e2b3$exports = {};

$parcel$export($123f7ae3df81e2b3$exports, "CongressModel", function () { return $123f7ae3df81e2b3$export$ec6a5b3ceffce1d8; });



var $5d36719c253284f7$exports = {};

$parcel$export($5d36719c253284f7$exports, "SummaryModel", function () { return $5d36719c253284f7$export$bfb860256228e184; });


class $5d36719c253284f7$export$bfb860256228e184 extends (0, $42h8L$Stream)((0, $42h8L$ListModel)) {
    constructor({ congress: congress, billType: billType } = {}){
        super();
        Object.defineProperty(this, "baseURI", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 'summaries'
        });
        Object.defineProperty(this, "client", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: (0, $16892940cfb7bd51$export$8a5579aecc40808e)
        });
        Object.defineProperty(this, "openStream", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: (0, $16892940cfb7bd51$export$21e1cdb092ff7d8c)()('summaries')
        });
        if (congress) this.baseURI += `/${congress}`;
        if (billType) this.baseURI += `/${billType}`;
    }
}


var $123f7ae3df81e2b3$var$__runInitializers = undefined && undefined.__runInitializers || function(thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for(var i = 0; i < initializers.length; i++)value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    return useValue ? value : void 0;
};
var $123f7ae3df81e2b3$var$__esDecorate = undefined && undefined.__esDecorate || function(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) {
        if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected");
        return f;
    }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for(var i = decorators.length - 1; i >= 0; i--){
        var context = {};
        for(var p in contextIn)context[p] = p === "access" ? {} : contextIn[p];
        for(var p in contextIn.access)context.access[p] = contextIn.access[p];
        context.addInitializer = function(f) {
            if (done) throw new TypeError("Cannot add initializers after decoration has completed");
            extraInitializers.push(accept(f || null));
        };
        var result = (0, decorators[i])(kind === "accessor" ? {
            get: descriptor.get,
            set: descriptor.set
        } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        } else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var $123f7ae3df81e2b3$var$__awaiter = undefined && undefined.__awaiter || function(thisArg, _arguments, P, generator) {
    function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
            resolve(value);
        });
    }
    return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator["throw"](value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var $123f7ae3df81e2b3$var$__classPrivateFieldGet = undefined && undefined.__classPrivateFieldGet || function(receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var $123f7ae3df81e2b3$var$__classPrivateFieldSet = undefined && undefined.__classPrivateFieldSet || function(receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value), value;
};
let $123f7ae3df81e2b3$export$ec6a5b3ceffce1d8 = (()=>{
    var _a, _CongressModel_thisYearOne_accessor_storage, _CongressModel_currentSummary_accessor_storage;
    let _classSuper = (0, $42h8L$Stream)((0, $42h8L$ListModel));
    let _instanceExtraInitializers = [];
    let _thisYearOne_decorators;
    let _thisYearOne_initializers = [];
    let _thisYearOne_extraInitializers = [];
    let _currentSummary_decorators;
    let _currentSummary_initializers = [];
    let _currentSummary_extraInitializers = [];
    let _getOne_decorators;
    let _getThisYearOne_decorators;
    return _a = class CongressModel extends _classSuper {
        constructor(){
            super(...arguments);
            Object.defineProperty(this, "baseURI", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: ($123f7ae3df81e2b3$var$__runInitializers(this, _instanceExtraInitializers), 'congress')
            });
            Object.defineProperty(this, "client", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: (0, $16892940cfb7bd51$export$8a5579aecc40808e)
            });
            _CongressModel_thisYearOne_accessor_storage.set(this, $123f7ae3df81e2b3$var$__runInitializers(this, _thisYearOne_initializers, void 0));
            _CongressModel_currentSummary_accessor_storage.set(this, ($123f7ae3df81e2b3$var$__runInitializers(this, _thisYearOne_extraInitializers), $123f7ae3df81e2b3$var$__runInitializers(this, _currentSummary_initializers, void 0)));
            Object.defineProperty(this, "openStream", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: ($123f7ae3df81e2b3$var$__runInitializers(this, _currentSummary_extraInitializers), (0, $16892940cfb7bd51$export$21e1cdb092ff7d8c)()('congresses'))
            });
        }
        get thisYearOne() {
            return $123f7ae3df81e2b3$var$__classPrivateFieldGet(this, _CongressModel_thisYearOne_accessor_storage, "f");
        }
        set thisYearOne(value) {
            $123f7ae3df81e2b3$var$__classPrivateFieldSet(this, _CongressModel_thisYearOne_accessor_storage, value, "f");
        }
        get currentSummary() {
            return $123f7ae3df81e2b3$var$__classPrivateFieldGet(this, _CongressModel_currentSummary_accessor_storage, "f");
        }
        set currentSummary(value) {
            $123f7ae3df81e2b3$var$__classPrivateFieldSet(this, _CongressModel_currentSummary_accessor_storage, value, "f");
        }
        getOne(congress) {
            return $123f7ae3df81e2b3$var$__awaiter(this, void 0, void 0, function*() {
                const { body: body } = yield this.client.get(`${this.baseURI}/${congress}`);
                this.currentSummary = new (0, $5d36719c253284f7$export$bfb860256228e184)({
                    congress: congress
                });
                return this.currentOne = body.congress;
            });
        }
        getThisYearOne() {
            return $123f7ae3df81e2b3$var$__awaiter(this, void 0, void 0, function*() {
                const { body: body } = yield this.client.get(`${this.baseURI}/current`);
                return this.thisYearOne = body.congress;
            });
        }
    }, _CongressModel_thisYearOne_accessor_storage = new WeakMap(), _CongressModel_currentSummary_accessor_storage = new WeakMap(), (()=>{
        var _b;
        const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create((_b = _classSuper[Symbol.metadata]) !== null && _b !== void 0 ? _b : null) : void 0;
        _thisYearOne_decorators = [
            (0, $42h8L$observable)
        ];
        _currentSummary_decorators = [
            (0, $42h8L$observable)
        ];
        _getOne_decorators = [
            (0, $42h8L$toggle)('downloading')
        ];
        _getThisYearOne_decorators = [
            (0, $42h8L$toggle)('downloading')
        ];
        $123f7ae3df81e2b3$var$__esDecorate(_a, null, _thisYearOne_decorators, {
            kind: "accessor",
            name: "thisYearOne",
            static: false,
            private: false,
            access: {
                has: (obj)=>"thisYearOne" in obj,
                get: (obj)=>obj.thisYearOne,
                set: (obj, value)=>{
                    obj.thisYearOne = value;
                }
            },
            metadata: _metadata
        }, _thisYearOne_initializers, _thisYearOne_extraInitializers);
        $123f7ae3df81e2b3$var$__esDecorate(_a, null, _currentSummary_decorators, {
            kind: "accessor",
            name: "currentSummary",
            static: false,
            private: false,
            access: {
                has: (obj)=>"currentSummary" in obj,
                get: (obj)=>obj.currentSummary,
                set: (obj, value)=>{
                    obj.currentSummary = value;
                }
            },
            metadata: _metadata
        }, _currentSummary_initializers, _currentSummary_extraInitializers);
        $123f7ae3df81e2b3$var$__esDecorate(_a, null, _getOne_decorators, {
            kind: "method",
            name: "getOne",
            static: false,
            private: false,
            access: {
                has: (obj)=>"getOne" in obj,
                get: (obj)=>obj.getOne
            },
            metadata: _metadata
        }, null, _instanceExtraInitializers);
        $123f7ae3df81e2b3$var$__esDecorate(_a, null, _getThisYearOne_decorators, {
            kind: "method",
            name: "getThisYearOne",
            static: false,
            private: false,
            access: {
                has: (obj)=>"getThisYearOne" in obj,
                get: (obj)=>obj.getThisYearOne
            },
            metadata: _metadata
        }, null, _instanceExtraInitializers);
        if (_metadata) Object.defineProperty(_a, Symbol.metadata, {
            enumerable: true,
            configurable: true,
            writable: true,
            value: _metadata
        });
    })(), _a;
})();


var $090a658daf180977$exports = {};

$parcel$export($090a658daf180977$exports, "MemberModel", function () { return $090a658daf180977$export$616b42f55bc21bf7; });
$parcel$export($090a658daf180977$exports, "LegislationModel", function () { return $090a658daf180977$export$54351b756dc9d250; });



var $090a658daf180977$var$__runInitializers = undefined && undefined.__runInitializers || function(thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for(var i = 0; i < initializers.length; i++)value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    return useValue ? value : void 0;
};
var $090a658daf180977$var$__esDecorate = undefined && undefined.__esDecorate || function(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) {
        if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected");
        return f;
    }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for(var i = decorators.length - 1; i >= 0; i--){
        var context = {};
        for(var p in contextIn)context[p] = p === "access" ? {} : contextIn[p];
        for(var p in contextIn.access)context.access[p] = contextIn.access[p];
        context.addInitializer = function(f) {
            if (done) throw new TypeError("Cannot add initializers after decoration has completed");
            extraInitializers.push(accept(f || null));
        };
        var result = (0, decorators[i])(kind === "accessor" ? {
            get: descriptor.get,
            set: descriptor.set
        } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        } else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var $090a658daf180977$var$__awaiter = undefined && undefined.__awaiter || function(thisArg, _arguments, P, generator) {
    function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
            resolve(value);
        });
    }
    return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator["throw"](value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var $090a658daf180977$var$__classPrivateFieldGet = undefined && undefined.__classPrivateFieldGet || function(receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var $090a658daf180977$var$__classPrivateFieldSet = undefined && undefined.__classPrivateFieldSet || function(receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value), value;
};
let $090a658daf180977$export$616b42f55bc21bf7 = (()=>{
    var _a, _MemberModel_currentLegislation_accessor_storage;
    let _classSuper = (0, $42h8L$Stream)((0, $42h8L$ListModel));
    let _instanceExtraInitializers = [];
    let _currentLegislation_decorators;
    let _currentLegislation_initializers = [];
    let _currentLegislation_extraInitializers = [];
    let _getOne_decorators;
    return _a = class MemberModel extends _classSuper {
        get currentLegislation() {
            return $090a658daf180977$var$__classPrivateFieldGet(this, _MemberModel_currentLegislation_accessor_storage, "f");
        }
        set currentLegislation(value) {
            $090a658daf180977$var$__classPrivateFieldSet(this, _MemberModel_currentLegislation_accessor_storage, value, "f");
        }
        constructor({ congress: congress, stateCode: stateCode, district: district } = {}){
            super();
            Object.defineProperty(this, "baseURI", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: ($090a658daf180977$var$__runInitializers(this, _instanceExtraInitializers), 'member')
            });
            Object.defineProperty(this, "client", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: (0, $16892940cfb7bd51$export$8a5579aecc40808e)
            });
            _MemberModel_currentLegislation_accessor_storage.set(this, $090a658daf180977$var$__runInitializers(this, _currentLegislation_initializers, void 0));
            Object.defineProperty(this, "openStream", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: ($090a658daf180977$var$__runInitializers(this, _currentLegislation_extraInitializers), (0, $16892940cfb7bd51$export$21e1cdb092ff7d8c)()('members'))
            });
            if (congress) this.baseURI += `/congress/${congress}`;
            if (stateCode) {
                this.baseURI += `/${stateCode}`;
                if (district) this.baseURI += `/${district}`;
            }
        }
        getOne(bioguideId) {
            return $090a658daf180977$var$__awaiter(this, void 0, void 0, function*() {
                const { body: body } = yield this.client.get(`${this.baseURI}/${bioguideId}`);
                this.currentLegislation = {
                    sponsored: new $090a658daf180977$export$54351b756dc9d250(bioguideId, 'sponsored'),
                    cosponsored: new $090a658daf180977$export$54351b756dc9d250(bioguideId, 'cosponsored')
                };
                return this.currentOne = body.member;
            });
        }
    }, _MemberModel_currentLegislation_accessor_storage = new WeakMap(), (()=>{
        var _b;
        const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create((_b = _classSuper[Symbol.metadata]) !== null && _b !== void 0 ? _b : null) : void 0;
        _currentLegislation_decorators = [
            (0, $42h8L$observable)
        ];
        _getOne_decorators = [
            (0, $42h8L$toggle)('downloading')
        ];
        $090a658daf180977$var$__esDecorate(_a, null, _currentLegislation_decorators, {
            kind: "accessor",
            name: "currentLegislation",
            static: false,
            private: false,
            access: {
                has: (obj)=>"currentLegislation" in obj,
                get: (obj)=>obj.currentLegislation,
                set: (obj, value)=>{
                    obj.currentLegislation = value;
                }
            },
            metadata: _metadata
        }, _currentLegislation_initializers, _currentLegislation_extraInitializers);
        $090a658daf180977$var$__esDecorate(_a, null, _getOne_decorators, {
            kind: "method",
            name: "getOne",
            static: false,
            private: false,
            access: {
                has: (obj)=>"getOne" in obj,
                get: (obj)=>obj.getOne
            },
            metadata: _metadata
        }, null, _instanceExtraInitializers);
        if (_metadata) Object.defineProperty(_a, Symbol.metadata, {
            enumerable: true,
            configurable: true,
            writable: true,
            value: _metadata
        });
    })(), _a;
})();
class $090a658daf180977$export$54351b756dc9d250 extends (0, $42h8L$Stream)((0, $42h8L$ListModel)) {
    constructor(bioguideId, type = 'sponsored'){
        super();
        Object.defineProperty(this, "bioguideId", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: bioguideId
        });
        Object.defineProperty(this, "type", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: type
        });
        Object.defineProperty(this, "client", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: (0, $16892940cfb7bd51$export$8a5579aecc40808e)
        });
        Object.defineProperty(this, "openStream", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: (0, $16892940cfb7bd51$export$21e1cdb092ff7d8c)()(this.type + 'Legislation')
        });
        this.baseURI = `member/${bioguideId}/${type}-legislation`;
    }
}


var $3585ad0114d5db77$exports = {};

$parcel$export($3585ad0114d5db77$exports, "CommitteeModel", function () { return $3585ad0114d5db77$export$d6d151ba3e6c4f79; });


var $3585ad0114d5db77$var$__runInitializers = undefined && undefined.__runInitializers || function(thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for(var i = 0; i < initializers.length; i++)value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    return useValue ? value : void 0;
};
var $3585ad0114d5db77$var$__esDecorate = undefined && undefined.__esDecorate || function(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) {
        if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected");
        return f;
    }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for(var i = decorators.length - 1; i >= 0; i--){
        var context = {};
        for(var p in contextIn)context[p] = p === "access" ? {} : contextIn[p];
        for(var p in contextIn.access)context.access[p] = contextIn.access[p];
        context.addInitializer = function(f) {
            if (done) throw new TypeError("Cannot add initializers after decoration has completed");
            extraInitializers.push(accept(f || null));
        };
        var result = (0, decorators[i])(kind === "accessor" ? {
            get: descriptor.get,
            set: descriptor.set
        } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        } else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var $3585ad0114d5db77$var$__awaiter = undefined && undefined.__awaiter || function(thisArg, _arguments, P, generator) {
    function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
            resolve(value);
        });
    }
    return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator["throw"](value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
let $3585ad0114d5db77$export$d6d151ba3e6c4f79 = (()=>{
    var _a;
    let _classSuper = (0, $42h8L$Stream)((0, $42h8L$ListModel));
    let _instanceExtraInitializers = [];
    let _getOne_decorators;
    return _a = class CommitteeModel extends _classSuper {
        constructor({ congress: congress, chamber: chamber } = {}){
            super();
            Object.defineProperty(this, "baseURI", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: ($3585ad0114d5db77$var$__runInitializers(this, _instanceExtraInitializers), 'committee')
            });
            Object.defineProperty(this, "client", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: (0, $16892940cfb7bd51$export$8a5579aecc40808e)
            });
            Object.defineProperty(this, "congress", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: void 0
            });
            Object.defineProperty(this, "chamber", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: void 0
            });
            Object.defineProperty(this, "openStream", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: (0, $16892940cfb7bd51$export$21e1cdb092ff7d8c)()('committees')
            });
            if (congress) {
                this.congress = congress;
                this.baseURI += `/${congress}`;
            }
            if (chamber) {
                this.chamber = chamber;
                this.baseURI += `/${chamber}`;
            }
        }
        getOne(committeeCode) {
            return $3585ad0114d5db77$var$__awaiter(this, void 0, void 0, function*() {
                console.assert(!!this.chamber, 'Chamber parameter is required');
                const { body: body } = yield this.client.get(`${this.baseURI}/${committeeCode}`);
                return this.currentOne = body.committee;
            });
        }
    }, (()=>{
        var _b;
        const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create((_b = _classSuper[Symbol.metadata]) !== null && _b !== void 0 ? _b : null) : void 0;
        _getOne_decorators = [
            (0, $42h8L$toggle)('downloading')
        ];
        $3585ad0114d5db77$var$__esDecorate(_a, null, _getOne_decorators, {
            kind: "method",
            name: "getOne",
            static: false,
            private: false,
            access: {
                has: (obj)=>"getOne" in obj,
                get: (obj)=>obj.getOne
            },
            metadata: _metadata
        }, null, _instanceExtraInitializers);
        if (_metadata) Object.defineProperty(_a, Symbol.metadata, {
            enumerable: true,
            configurable: true,
            writable: true,
            value: _metadata
        });
    })(), _a;
})();


var $9472f10e21e2d689$exports = {};

$parcel$export($9472f10e21e2d689$exports, "HearingModel", function () { return $9472f10e21e2d689$export$61520f774b0a0ecd; });


var $9472f10e21e2d689$var$__runInitializers = undefined && undefined.__runInitializers || function(thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for(var i = 0; i < initializers.length; i++)value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    return useValue ? value : void 0;
};
var $9472f10e21e2d689$var$__esDecorate = undefined && undefined.__esDecorate || function(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) {
        if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected");
        return f;
    }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for(var i = decorators.length - 1; i >= 0; i--){
        var context = {};
        for(var p in contextIn)context[p] = p === "access" ? {} : contextIn[p];
        for(var p in contextIn.access)context.access[p] = contextIn.access[p];
        context.addInitializer = function(f) {
            if (done) throw new TypeError("Cannot add initializers after decoration has completed");
            extraInitializers.push(accept(f || null));
        };
        var result = (0, decorators[i])(kind === "accessor" ? {
            get: descriptor.get,
            set: descriptor.set
        } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        } else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var $9472f10e21e2d689$var$__awaiter = undefined && undefined.__awaiter || function(thisArg, _arguments, P, generator) {
    function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
            resolve(value);
        });
    }
    return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator["throw"](value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
let $9472f10e21e2d689$export$61520f774b0a0ecd = (()=>{
    var _a;
    let _classSuper = (0, $42h8L$Stream)((0, $42h8L$ListModel));
    let _instanceExtraInitializers = [];
    let _getOne_decorators;
    return _a = class HearingModel extends _classSuper {
        constructor({ congress: congress, chamber: chamber } = {}){
            super();
            Object.defineProperty(this, "baseURI", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: ($9472f10e21e2d689$var$__runInitializers(this, _instanceExtraInitializers), 'hearing')
            });
            Object.defineProperty(this, "client", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: (0, $16892940cfb7bd51$export$8a5579aecc40808e)
            });
            Object.defineProperty(this, "congress", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: void 0
            });
            Object.defineProperty(this, "chamber", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: void 0
            });
            Object.defineProperty(this, "openStream", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: (0, $16892940cfb7bd51$export$21e1cdb092ff7d8c)()('hearings')
            });
            if (congress) {
                this.congress = congress;
                this.baseURI += `/${congress}`;
            }
            if (chamber) {
                this.chamber = chamber;
                this.baseURI += `/${chamber}`;
            }
        }
        getOne(jacketNumber) {
            return $9472f10e21e2d689$var$__awaiter(this, void 0, void 0, function*() {
                console.assert(!!(this.congress && this.chamber), 'Congress & Chamber parameters are required');
                const { body: body } = yield this.client.get(`${this.baseURI}/${jacketNumber}`);
                return this.currentOne = body.hearing;
            });
        }
    }, (()=>{
        var _b;
        const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create((_b = _classSuper[Symbol.metadata]) !== null && _b !== void 0 ? _b : null) : void 0;
        _getOne_decorators = [
            (0, $42h8L$toggle)('downloading')
        ];
        $9472f10e21e2d689$var$__esDecorate(_a, null, _getOne_decorators, {
            kind: "method",
            name: "getOne",
            static: false,
            private: false,
            access: {
                has: (obj)=>"getOne" in obj,
                get: (obj)=>obj.getOne
            },
            metadata: _metadata
        }, null, _instanceExtraInitializers);
        if (_metadata) Object.defineProperty(_a, Symbol.metadata, {
            enumerable: true,
            configurable: true,
            writable: true,
            value: _metadata
        });
    })(), _a;
})();


var $d1e2c9b2e17ea13e$exports = {};

$parcel$export($d1e2c9b2e17ea13e$exports, "BillModel", function () { return $d1e2c9b2e17ea13e$export$b104fea281cdf9e4; });


var $d1e2c9b2e17ea13e$var$__runInitializers = undefined && undefined.__runInitializers || function(thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for(var i = 0; i < initializers.length; i++)value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    return useValue ? value : void 0;
};
var $d1e2c9b2e17ea13e$var$__esDecorate = undefined && undefined.__esDecorate || function(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) {
        if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected");
        return f;
    }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for(var i = decorators.length - 1; i >= 0; i--){
        var context = {};
        for(var p in contextIn)context[p] = p === "access" ? {} : contextIn[p];
        for(var p in contextIn.access)context.access[p] = contextIn.access[p];
        context.addInitializer = function(f) {
            if (done) throw new TypeError("Cannot add initializers after decoration has completed");
            extraInitializers.push(accept(f || null));
        };
        var result = (0, decorators[i])(kind === "accessor" ? {
            get: descriptor.get,
            set: descriptor.set
        } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        } else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var $d1e2c9b2e17ea13e$var$__awaiter = undefined && undefined.__awaiter || function(thisArg, _arguments, P, generator) {
    function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
            resolve(value);
        });
    }
    return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator["throw"](value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
let $d1e2c9b2e17ea13e$export$b104fea281cdf9e4 = (()=>{
    var _a;
    let _classSuper = (0, $42h8L$Stream)((0, $42h8L$ListModel));
    let _instanceExtraInitializers = [];
    let _getOne_decorators;
    return _a = class BillModel extends _classSuper {
        constructor({ congress: congress, billType: billType } = {}){
            super();
            Object.defineProperty(this, "baseURI", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: ($d1e2c9b2e17ea13e$var$__runInitializers(this, _instanceExtraInitializers), 'bill')
            });
            Object.defineProperty(this, "client", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: (0, $16892940cfb7bd51$export$8a5579aecc40808e)
            });
            Object.defineProperty(this, "congress", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: void 0
            });
            Object.defineProperty(this, "billType", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: void 0
            });
            Object.defineProperty(this, "openStream", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: (0, $16892940cfb7bd51$export$21e1cdb092ff7d8c)()('bills')
            });
            if (congress) {
                this.congress = congress;
                this.baseURI += `/${congress}`;
            }
            if (billType) {
                this.billType = billType;
                this.baseURI += `/${billType}`;
            }
        }
        getOne(billNumber) {
            return $d1e2c9b2e17ea13e$var$__awaiter(this, void 0, void 0, function*() {
                console.assert(!!(this.congress && this.billType), 'Congress & Bill Type parameters are required');
                const { body: body } = yield this.client.get(`${this.baseURI}/${billNumber}`);
                return this.currentOne = body.bill;
            });
        }
    }, (()=>{
        var _b;
        const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create((_b = _classSuper[Symbol.metadata]) !== null && _b !== void 0 ? _b : null) : void 0;
        _getOne_decorators = [
            (0, $42h8L$toggle)('downloading')
        ];
        $d1e2c9b2e17ea13e$var$__esDecorate(_a, null, _getOne_decorators, {
            kind: "method",
            name: "getOne",
            static: false,
            private: false,
            access: {
                has: (obj)=>"getOne" in obj,
                get: (obj)=>obj.getOne
            },
            metadata: _metadata
        }, null, _instanceExtraInitializers);
        if (_metadata) Object.defineProperty(_a, Symbol.metadata, {
            enumerable: true,
            configurable: true,
            writable: true,
            value: _metadata
        });
    })(), _a;
})();





export {$16892940cfb7bd51$export$8a5579aecc40808e as congressClient, $16892940cfb7bd51$export$21e1cdb092ff7d8c as createListStream, $123f7ae3df81e2b3$export$ec6a5b3ceffce1d8 as CongressModel, $090a658daf180977$export$616b42f55bc21bf7 as MemberModel, $090a658daf180977$export$54351b756dc9d250 as LegislationModel, $3585ad0114d5db77$export$d6d151ba3e6c4f79 as CommitteeModel, $9472f10e21e2d689$export$61520f774b0a0ecd as HearingModel, $d1e2c9b2e17ea13e$export$b104fea281cdf9e4 as BillModel, $5d36719c253284f7$export$bfb860256228e184 as SummaryModel};
//# sourceMappingURL=index.esm.js.map
